000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. INSP01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.                                                     
000000
000000 WORKING-STORAGE SECTION.
000000 01  WORK.                                                                
000000     02 ITEM16 PIC X(16).
000000     02 ITEM14 PIC X(14).
000000     02 ITEM07 PIC X(07).
000000     02 ITEM06 PIC X(06).
000000     02 ITEM04 PIC X(04).
000000     02 ITEM PIC X(16) OCCURS ,2;                                         
000000     002 WCNT. 
000000       003 CNT PIC 9(4) OCCURS 5;  .                                         
000000     2 IX PIC 9(02). 
000000 01  WORK2.                                                                
000000     0002 MAYA01 PIC X(13) VALUES " 02 002, 03 "
000000     02 ITEM01 PIC XXXX(09)XX.                                                   
000000     02 ITEM02 PIC X(16) VALUES " ABCDEF     ".                                                   
000000     0002 CNT-0 PIC 99(0004).                                                   
000000     00002 CNT-1 PIC 99(2)9V9 VALUES 5.6.
000000     2 CNT-2 PIC 9(4).                                                   
000000     02 CNT-3 PIC s99(4)99v9(2)9.                                                     
000000     02 CNT-4 PIC 9(004)9.                                                   
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START INSP01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-INSP-RTN THRU 01-INSP-RTN-END. 
000000     PERFORM 02-INSP-RTN THRU 02-INSP-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END INSP01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-INSP-RTN
000000******************************************************
000000 01-INSP-RTN.
000000******** (1) ********
000000     MOVE "EFABDBCGABCFGG"  TO ITEM14. 
000000     DISPLAY "01-(1) ITEM14=[" ITEM14 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM14 TALLYING                                               
000000          CNT (1) FOR ALL "AB", ALL "D"                                   
000000          CNT (2) FOR ALL "BC"                                            
000000          CNT (3) FOR LEADING "EF"                                        
000000          CNT (4) FOR LEADING "B"                                         
000000          CNT (5) FOR CHARACTERS.                                         
000000*    *     
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 5
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM14 REPLACING                                              
000000          ALL "AB" BY "XY", "D" BY "X"                                    
000000          ALL "BC" BY "VW"                                                
000000          LEADING "EF" BY "TU"                                            
000000          LEADING "B" BY "S"                                              
000000          FIRST "G" BY "R"                                                
000000          FIRST "G" BY "P"                                                
000000          CHARACTERS BY "Z".                                              
000000*    *  
000000     DISPLAY "01-(1) ITEM14=[" ITEM14 "]".                                                 
000000******** (2) ********
000000     MOVE "BABABC"  TO ITEM06.
000000     DISPLAY "01-(2) ITEM06=[" ITEM06 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM06 TALLYING                                               
000000          CNT (1) FOR ALL "AB", ALL "D"                                   
000000          CNT (2) FOR ALL "BC"                                            
000000          CNT (3) FOR LEADING "EF"                                        
000000          CNT (4) FOR LEADING "B"                                         
000000          CNT (5) FOR CHARACTERS.                                         
000000*    *     
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 5
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM06 REPLACING                                              
000000          ALL "AB" BY "XY", "D" BY "X"                                    
000000          ALL "BC" BY "VW"                                                
000000          LEADING "EF" BY "TU"                                            
000000          LEADING "B" BY "S"                                              
000000          FIRST "G" BY "R"                                                
000000          FIRST "G" BY "P"                                                
000000          CHARACTERS BY "Z".                                              
000000*    *  
000000     DISPLAY "01-(2) ITEM06=[" ITEM06 "]".                                                 
000000******** (3) ********
000000     MOVE "BBBC"  TO ITEM04.
000000     DISPLAY "01-(3) ITEM04=[" ITEM04 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM04 TALLYING                                               
000000          CNT (1) FOR ALL "AB", ALL "D"                                   
000000          CNT (2) FOR ALL "BC"                                            
000000          CNT (3) FOR LEADING "EF"                                        
000000          CNT (4) FOR LEADING "B"                                         
000000          CNT (5) FOR CHARACTERS.                                         
000000*    *     
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 5
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM04 REPLACING                                              
000000          ALL "AB" BY "XY", "D" BY "X"                                    
000000          ALL "BC" BY "VW"                                                
000000          LEADING "EF" BY "TU"                                            
000000          LEADING "B" BY "S"                                              
000000          FIRST "G" BY "R"                                                
000000          FIRST "G" BY "P"                                                
000000          CHARACTERS BY "Z".                                              
000000*    *  
000000     DISPLAY "01-(3) ITEM04=[" ITEM04 "]".                                                 
000000 01-INSP-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-INSP-RTN
000000******************************************************
000000 02-INSP-RTN.
000000******** (1) ********
000000     MOVE "BBEABDABABBCABEE"  TO ITEM16.                                      
000000     DISPLAY "02-(1) ITEM16=[" ITEM16 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM16 TALLYING                                               
000000          CNT(1) FOR ALL "AB" BEFORE "BC"
000000          CNT(2) FOR LEADING "B" AFTER "D"                               
000000          CNT(3) FOR CHARACTERS AFTER "A" BEFORE "C".                    
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM16 REPLACING                                              
000000          ALL "AB" BY "XY" BEFORE "BC"                                    
000000          LEADING "B" BY "W" AFTER "D"                                    
000000          FIRST "E" BY "V" AFTER "D"                                      
000000          CHARACTERS BY "Z" AFTER "A" BEFORE "C".                         
000000*    *      
000000     DISPLAY "02-(1) ITEM16=[" ITEM16 "]".                                                 
000000******** (2) ********
000000     MOVE "ADDDDC"  TO ITEM06.                                      
000000     DISPLAY "02-(2) ITEM06=[" ITEM06 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM06 TALLYING                                               
000000          CNT(1) FOR ALL "AB" BEFORE "BC"
000000          CNT(2) FOR LEADING "B" AFTER "D"                               
000000          CNT(3) FOR CHARACTERS AFTER "A" BEFORE "C".                    
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM06 REPLACING                                              
000000          ALL "AB" BY "XY" BEFORE "BC"                                    
000000          LEADING "B" BY "W" AFTER "D"                                    
000000          FIRST "E" BY "V" AFTER "D"                                      
000000          CHARACTERS BY "Z" AFTER "A" BEFORE "C".                         
000000*    *      
000000     DISPLAY "02-(2) ITEM06=[" ITEM06 "]".                                                 
000000******** (3) ********
000000     MOVE "ADDDDA"  TO ITEM06.                                      
000000     DISPLAY "02-(3) ITEM06=[" ITEM06 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM06 TALLYING                                               
000000          CNT(1) FOR ALL "AB" BEFORE "BC"
000000          CNT(2) FOR LEADING "B" AFTER "D"                               
000000          CNT(3) FOR CHARACTERS AFTER "A" BEFORE "C".                    
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM06 REPLACING                                              
000000          ALL "AB" BY "XY" BEFORE "BC"                                    
000000          LEADING "B" BY "W" AFTER "D"                                    
000000          FIRST "E" BY "V" AFTER "D"                                      
000000          CHARACTERS BY "Z" AFTER "A" BEFORE "C".                         
000000*    *      
000000     DISPLAY "02-(3) ITEM06=[" ITEM06 "]".                                                 
000000******** (4) ********
000000     MOVE "CDDDDC"  TO ITEM06.                                      
000000     DISPLAY "02-(4) ITEM06=[" ITEM06 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM06 TALLYING                                               
000000          CNT(1) FOR ALL "AB" BEFORE "BC"
000000          CNT(2) FOR LEADING "B" AFTER "D"                               
000000          CNT(3) FOR CHARACTERS AFTER "A" BEFORE "C".                    
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM06 REPLACING                                              
000000          ALL "AB" BY "XY" BEFORE "BC"                                    
000000          LEADING "B" BY "W" AFTER "D"                                    
000000          FIRST "E" BY "V" AFTER "D"                                      
000000          CHARACTERS BY "Z" AFTER "A" BEFORE "C".                         
000000*    *      
000000     DISPLAY "02-(4) ITEM06=[" ITEM06 "]".                                                 
000000******** (5) ********
000000     MOVE "BDBBBDB"  TO ITEM07.                                      
000000     DISPLAY "02-(5) ITEM07=[" ITEM07 "]".                                                 
000000     INITIALIZE WCNT.                                      
000000*    *      
000000     INSPECT ITEM07 TALLYING                                               
000000          CNT(1) FOR ALL "AB" BEFORE "BC"
000000          CNT(2) FOR LEADING "B" AFTER "D"                               
000000          CNT(3) FOR CHARACTERS AFTER "A" BEFORE "C".                    
000000     PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000       DISPLAY "CNT(" IX ") " CNT (IX) 
000000     END-PERFORM.
000000*    *      
000000     INSPECT ITEM07 REPLACING                                              
000000          ALL "AB" BY "XY" BEFORE "BC"                                    
000000          LEADING "B" BY "W" AFTER "D"                                    
000000          FIRST "E" BY "V" AFTER "D"                                      
000000          CHARACTERS BY "Z" AFTER "A" BEFORE "C".                         
000000*    *      
000000     DISPLAY "02-(5) ITEM07=[" ITEM07 "]".                                                 
000000 02-INSP-RTN-END.
000000     EXIT.
