000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. SET02.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  WW. 
000000     02 SW2 PIC 9 02 SW PIC 9.
000000      02 AC-STR PIC X(5). 
000000      02 AC-LONG PIC 9(5). 
000000      02 AC-LONG2 PIC s9(5). 
000000      02 AC-FLOAT PIC 9(4)V99. 
000000      02 AC-FLOAT2 PIC s9(4)V99. 
000000  01 WCNT.
000000     02 CNT PIC 9(5) OCCURS 5 
000000          INDEXED BY CI01 CI02 CI03 CI04 CI05.
000000 01  UIX USAGE INDEX. 
000000 77  YIX USAGE INDEX.
000000 01  WWW.
000000     02 ZIX  USAGE IS INDEX.
000000  01 GENGO-W.
000000     02 PIC X(10) VALUE "COBOL"  002 PIC 9(3)  VALUE 100.
000000     02 PIC X(10) VALUE "FORTRAN".
000000     02 PIC 9(3)  VALUE 120.
000000     02 PIC X(10) VALUE "C". 02 PIC 9(3)  VALUE 200.
000000     02 PIC X(10) VALUE "C++".
000000     02 PIC 9(3)  VALUE 210.
000000     02 PIC X(10) VALUE "BASIC".
000000     02 PIC 9(3)  VALUE 300.
000000     02 PIC X(10) VALUE "PERL".
000000     02 PIC 9(3)  VALUE 400.
000000     02 PIC X(10) VALUE "PHP".
000000     02 PIC 9(3)  VALUE 410.
000000     02 PIC X(10) VALUE "VB.NET".
000000     02 PIC 9(3)  VALUE 500.
000000     02 PIC X(10) VALUE "C#.NET".
000000     02 PIC 9(3)  VALUE 510.
000000  01 REDEFINES GENGO-W.
000000     02 GENGO OCCURS 9 TIMES 
000000          INDEXED BY IX01 IX02 IX03 IX04 IX05.
000000      03 G-NAME PIC X(10).
000000      03 G-NO   PIC 9(3).
000000  01  WORK.
000000      03 KUNI-JYOHO.                      
000000        05 FILLER PIC X(19) VALUE "001Canada   America". 
000000        05 FILLER PIC X(19) VALUE "001Hawaii   Oceania". 
000000        05 FILLER PIC X(19) VALUE "001USA      America". 
000000        05 FILLER PIC X(19) VALUE "007Russia   Europe ". 
000000        05 FILLER PIC X(19) VALUE "049Germany  Europe ". 
000000        05 FILLER PIC X(19) VALUE "081Japan    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "082Korea    Asia   ". 
000000        05 FILLER PIC X(19) VALUE "084Viet Nam Asia   ". 
000000        05 FILLER PIC X(19) VALUE "086China    Asia   ".
000000        05 FILLER PIC X(19) VALUE "090Turkey   Europe ".
000000        05 FILLER PIC X(19) VALUE "680Palau    Oceania". 
000000        05 FILLER PIC X(19) VALUE "852Hong KongAsia   ".
000000        05 FILLER PIC X(19) VALUE "886Taiwan   Asia   ".
000000      03 KUNI-JYOHO-R REDEFINES KUNI-JYOHO.          
000000        05 KUNI-TBL OCCURS 13 ASCENDING KEY KUNI 
000000                      INDEXED BY KI01 KI02 KI03 KI04 KI05.   
000000          07 KUNI .         
000000            09 KUNI-NO   PIC 9(03).
000000            09 KUNI-NAME PIC X(09).         
000000          07 KUNI-CHIIKI PIC X(7).   
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START SET02" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-SET-RTN THRU 01-SET-RTN-END. 
000000     PERFORM 01-ACCEPT-RTN THRU 01-ACCEPT-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END SET02" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SET-RTN rds, USAGE INDEX 
000000******************************************************
000000 01-SET-RTN.
000000     SET CI05 TO 1.
000000     SET UIX YIX ZIX TO CI05.
000000     MOVE 3 TO CNT (CI05). 
000000     SET CI01 CI02 CI03 CI04 CI05 TO CNT ( CI05 ).
000000     DISPLAY "SET(1) ci01=" CI01 " ci05=" CI05 
000000       " UIX=" UIX " YIX=" YIX " ZIX=" ZIX.  
000000     SET IX01 IX02 IX03 IX04 IX05 TO 5.
000000     DISPLAY "SET(2) IX01=" IX01 " g-name=" G-NAME (IX01).
000000     SET  KI01 KI02 KI03 KI04 KI05 TO 13.
000000     DISPLAY "SET(3) KI05=" KI05 " kuni-name=" KUNI-NAME (KI05).
000000 01-SET-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-ACCEPT-RTN  ACCEPT
000000******************************************************
000000 01-ACCEPT-RTN.
000000     MOVE 0 TO SW.
000000     PERFORM UNTIL SW = 1
000000       DISPLAY "--- ACCEPT STRING ---(^:end)"
000000       ACCEPT AC-STR
000000       IF AC-STR = "^" 
000000         MOVE 1 TO SW
000000       ELSE
000000         DISPLAY " str=" AC-STR
000000       END-IF
000000     END-PERFORM.
000000*    ***
000000     MOVE 0 TO SW.
000000     PERFORM UNTIL SW = 1
000000       DISPLAY "--- ACCEPT LONG 9(5)---(99999:end)"
000000       ACCEPT AC-LONG
000000       IF AC-LONG = 99999
000000         MOVE 1 TO SW
000000       ELSE
000000         DISPLAY " long=" AC-LONG
000000       END-IF
000000     END-PERFORM.
000000*    ***
000000     MOVE 0 TO SW.
000000     PERFORM UNTIL SW = 1
000000       DISPLAY "--- ACCEPT LONG s9(5)---(99999:end)"
000000       ACCEPT AC-LONG2
000000       IF AC-LONG2 = 99999
000000         MOVE 1 TO SW
000000       ELSE
000000         DISPLAY " long=" AC-LONG2
000000       END-IF
000000     END-PERFORM.
000000*    ***
000000     MOVE 0 TO SW.
000000     PERFORM UNTIL SW = 1
000000       DISPLAY "--- ACCEPT FLOAT 9(4)v99---(999.99:end)"
000000       ACCEPT AC-FLOAT
000000       IF AC-FLOAT = 999.99
000000         MOVE 1 TO SW
000000       ELSE
000000         DISPLAY " float=" AC-FLOAT
000000       END-IF
000000     END-PERFORM.
000000*    ***
000000     MOVE 0 TO SW.
000000     PERFORM UNTIL SW = 1
000000       DISPLAY "--- ACCEPT FLOAT s9(4)v99---(999.99:end)"
000000       ACCEPT AC-FLOAT2
000000       IF AC-FLOAT2 = 999.99
000000         MOVE 1 TO SW
000000       ELSE
000000         DISPLAY " float=" AC-FLOAT2
000000       END-IF
000000     END-PERFORM.
000000 01-ACCEPT-RTN-END.
000000     EXIT.
