#!/usr/bin/perl
#################################################################################################
# Copyright (C) 2016 Jokanji
# 2016.06-> Jokanji(m.ma)
#################################################################################################
# cob_to_bigdecimal_set.pl (Ver 1.0) 
#  Jokanji
# 2016.06 start..
# 201x.xx.xx ...
#################################################################################################
# e
# COBOL  RUBY ֕ϊ 'BigDecimal' Zbg
# ၄
# $su23 = 1234567890123456789.12345678 * -37899.7792156; $_SC=1; Set("su23",$su23,"");
#@@     
# $su23 = BigDecimal("1234567890123456789.12345678") * BigDecimal("-37899.7792156"); $_SC=1; Set("su23",$su23,"");

# print "01 SU23=" , $su23,"\n";
#@@     
# print "01 SU23=",$su23.to_s("F"),"\n";
#################################################################################################
#-***** Global Variable:O[oϐ *****
@In=();  $Ix=0;
@Ind=();  $Ixd=0;
%Hdd=();

#################################################################################################
#-Perl Start

  &start_rtn();
  &main01_rtn();
  &end01_rtn();

  exit;
#################################################################################################
sub start_rtn
{
  $inpf = $ARGV[0]; #--input file R}hC
  if (!(-e $inpf)){
    print "R}hC:0 (input t@C)\n";
    print "t@C [$inpf] ݂͑܂I\n"; exit; 
  }

  print "cob_to_bigdecimal_set.pl\n";

  open IN, $inpf;
  while (my $in=<IN>){
    chomp $in;
    $In[$Ix++]=$in;
  }
  close IN;

  my $inpf_dd = $inpf; $inpf_dd =~ s/\.rb/_dd\.rb/;
  open IN, $inpf_dd;
  while (my $in=<IN>){
    chomp $in;
    $Ind[$Ixd++]=$in;
  }
  close IN;
}
#################################################################################################
sub main01_rtn
{
  for (my $i=0;$i<$Ixd;$i++){
    my $ss=$Ind[$i];
    my $ln=length($ss);
    if ($ss =~ /\$Hdd\[/){
        #$Hdd["su23"]="02w&|s9(20)v9(8)|0|0|work_su2|0|164|30|8|31"; $Avar[$Aix]="su23"; $Aix+=1;
        my @sz=split(/ +/,$ss);
        my ($s00,$s10)=split(/\=/,$sz[2]); my $var=$s10; $var =~ s/\"|\;//g; $var='$'.$var; 
        my ($s01,$s11)=split(/\=/,$sz[1]); $s11 =~ s/\"|\;//g;
        $Hdd{$var}=$s11;
    }
  }

  #foreach $key (sort keys %Hdd){
  #  print "$key $Hdd{$key}\n";
  #}

  my $sw=0;
  for (my $i=0;$i<$Ix;$i++){
    my $ss=$In[$i];
    my $ln=length($ss);
    if ($ss =~ / _main_ /){ $sw=1; next; }
    if ($sw==0){ next; }

    if ($ss =~ / \= / && $ss =~ / Set\(\"/){
      &b_decimal_set($ss,$i);
    }
    if ($ss =~ /print /){
      &print_set($ss,$i);
    }
  }
}
#################################################################################################
# $su23 = 1234567890123456789.12345678 * -37899.7792156; $_SC=1; Set("su23",$su23,"");
sub b_decimal_set
{
  my ($ss,$i)=@_;

      my $ok=0;

      my @sp=split(/ +/,$ss);
      for (my $j=0;$j<=$#sp;$j++){
        if (exists $Hdd{$sp[$j]} && $j+1<=$#sp && $sp[$j+1] eq "="){
          my @sa=split(/\|/,$Hdd{$sp[$j]});
          if ($sa[9] eq "20" || $sa[9] eq "21" || $sa[9] eq "30" || $sa[9] eq "31"){
            $semic="";
            for (my $k=$j+2;$k<=$#sp;$k++){
              if ($sp[$k] =~ /\;/){
                $sp[$k] =~ s/\;//g; $semic=";";
              }
              if ($sp[$k] =~ /^[-+]?[0-9]*(\.[0-9]*)?$/){ #double(float)
                #if (length($sp[$k]) >=10){
                  $sp[$k]="BigDecimal('".$sp[$k]."')".$semic; $ok=1;
                #}
              }
              elsif (exists $Hdd{$sp[$k]}){
                my @sb=split(/\|/,$Hdd{$sp[$k]});
                if ($sb[9] eq "40" || $sb[9] eq "41"){
                  $sp[$k]="BigDecimal('".$sp[$k]."')".$semic; $ok=1;
                }  
              }
              else{
                $sp[$k]=$sp[$k].$semic;
              }
              if ($semic eq ";"){ break; }
            }
          }
        }
      }
      if ($ok==1){
        my $ln=0;
        if ($ss =~ /\A([ ]*)([^ ].*)\z/s){ $ln=length $1; }
        $ss=join(' ',@sp);
        if ($ln==0){
          $ss =~ s/^\s*//;
        }
        elsif ($ln >0){
          $ss =~ s/^\s*//;
          my $s=' ' x $ln;
          $ss=$s.$ss;
        }
        $In[$i]=$ss;
      }

}
#################################################################################################
#   print "01 SU23=" , $su23,"\n";
sub print_set
{
  my ($ss,$i)=@_;

      my $ok=0;

      my @sp=split(/,/,$ss);
      for (my $j=0;$j<=$#sp;$j++){
        $sp[$j] =~ s/^\s*(.*?)\s*$/$1/; #-trim
        if (exists $Hdd{$sp[$j]}){
          my @sa=split(/\|/,$Hdd{$sp[$j]});
          if ($sa[9] eq "21" || $sa[9] eq "31"){
            $sp[$j]=$sp[$j].'.to_s("F")';
            $ok=1; 
          }
          if ($sa[9] eq "20" || $sa[9] eq "30"){
            $sp[$j]=$sp[$j].'.to_s("f")';
            $ok=1; 
          }
        }
      }
      if ($ok==1){
        my $ln=0;
        if ($ss =~ /\A([ ]*)([^ ].*)\z/s){ $ln=length $1; }
        $ss=join(',',@sp);
        if ($ln==0){
          $ss =~ s/^\s*//;
        }
        elsif ($ln >0){
          $ss =~ s/^\s*//;
          my $s=' ' x $ln;
          $ss=$s.$ss;
        }
        $In[$i]=$ss;
      }
}
#################################################################################################
sub end01_rtn
{
  my $outf=$inpf;
  $outf =~ s/\.rb//g; $outf=$outf.'_bdc.rb';
  open OUT, ">$outf";
  for (my $i=0;$i<$Ix;$i++){
    if ($i <=2 && $In[$i] =~ /$inpf/){
      $In[$i] =~ s/$inpf/$outf/g;
    }
    print OUT "$In[$i]\n";
  }
  close OUT;
}
#################################################################################################
